
var client;

(async function init() {
  client = await app.initialized();
  client.events.on('app.activated', onAppActivate)
})();



function logError(e) {console.log(e)}

async function getCfg(var_name) {
  function returnCfg(iparams) {return iparams[var_name]}
  return await client.iparams.get(var_name).then(returnCfg).catch(logError)
}

async function onAppActivate() {
  console.log('onAppActivate for app')
  document.getElementById('showModal').addEventListener('fwClick', showModal)
  // Define the function that receives data from modal
  client.instance.receive(
   function (event) {
     var data = event.helper.getData();
     console.info('Data from Modal', data)
     console.info(event);
   }
  )
  // var contact=await getContactId()
  // // contact_id=2343434 // Uncomment to see how error is handled (error printed by _asyncRequest and null returned)
  // // var contact = await getContact(contact_id); if(!contact) return
  // console.log('contact', contact_id)
}


async function getContact(contact_id) {
  var res = await _asyncRequest('get', `/contacts/${contact_id}?include=owner,sales_account`)
  return res
}

async function _asyncRequest(method, path, body={}) {  // client.request wrapper
  // Returns response object or prints error and returns null. Use await to wait for result
  if(window.debug) log('HTTP REQUEST -> URL: GET', window.baseurl)
  var headers, baseurl=`https://${await getCfg('crm_domain')}/crm/sales/api`, url=baseurl+path
  if (method=='get')
    headers={Authorization: `Token token=<%= iparam.crm_api_key %>`};
  else
    headers={'Content-Type': 'application/json', Authorization: `Token token=<%= iparam.crm_api_key %>`}
  function returnResponse(data) { return JSON.parse(data.response) }
  function returnError(data) { console.error(data); return null }
  return await client.request[method](url, { body: JSON.stringify(body), headers: headers } )
  .then(returnResponse).catch(returnError)
}


function showModal() {
  console.log('showModal for app')
  client.interface.trigger("showModal", {
    title: "Sample Modal",
    template: "views/modal.html",
    data: {
      name:'Steve rogers',
      Designation: 'Captain America'
    }
  }).then(console.log).catch(logError)
}

function log(msg){
  console.log(msg);
}

function handleErr(err) {
  console.error(`Error occured. Details:`, err);
}

function fetchFromModal() {
 client.instance.receive(
   function (event) {
     var data = event.helper.getData();
     console.info('Data from Modal', data)
     console.info(event);
   }
 );
}

async function getContactId() { // Get contact id from currentEntityInfo
  // data: { 'currentEntityInfo': { 'currentEntityId': 12, 'currentEntityType': 'contact'}}
  return await client.data.get('currentEntityInfo').then(getId).catch(logError)
  function getId(data) {
    if(data.currentEntityInfo.currentEntityType=='contact') {
      console.log(data.currentEntityInfo)
      var contact_id=data.currentEntityInfo.currentEntityId
      console.log('CONTACT ID', contact_id)
      return contact_id
    }
  }
}
