var client;

(async function init() {
  client = await app.initialized();
  client.events.on('app.activated', onAppActivate)
})();

function onAppActivate() {
  var textElement = document.getElementById('apptext')
  var getContact = window.client.data.get('contact')
  getContact.then(showContact).catch(handleErr)

  function showContact(payload) {
    textElement.innerHTML = `Ticket created by ${payload.contact.name}`
  }
}

function log(msg){
  console.log(msg)
}

function closeModal() {
  sendFromModal()
  console.log('Closing modal')
  client.instance.close()
}

function handleErr(err) {
  console.error(`Error occured. Details:`, err)
}

function fetchData() {
  function logContext(context) {console.log(context.data)}
  client.instance.context().then(logContext).catch(handleErr)
}

function sendFromModal() {
  console.log(window);
  client.instance.send({
    message: 'Info received about captain America'
  })
}
